diff --git a/changelog b/changelog
index 1e53de8..8a8dc2b 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20081226 tpd src/axiom-website/patches.html 20081225.04.tpd.patch
+20081226 tpd src/algebra/Makefile rearrange build order
 20081225 tpd src/axiom-website/patches.html 20081225.04.tpd.patch
 20081225 tpd src/algebra/Makefile move layers 15-19
 20081225 tpd src/axiom-website/patches.html 20081225.03.tpd.patch
diff --git a/src/algebra/Makefile.pamphlet b/src/algebra/Makefile.pamphlet
index 4335faf..6b99258 100644
--- a/src/algebra/Makefile.pamphlet
+++ b/src/algebra/Makefile.pamphlet
@@ -83,6 +83,15 @@ stanzas before continuing upward.
 
 \section{The Algebra Lattice Layers}
 \subsection{Layer 0 Bootstrap}
+The easiest way to find out where a spad file lives in the hierarchy
+is to create the following script (called 'show'):
+\begin{verbatim}
+  echo ")co $1" | AXIOMsys >out
+  fgrep abbreviates out
+  fgrep "Loading" out | grep -v autoload
+\end{verbatim}
+and then run it with ``./show FOO'' where the algebra source file
+is FOO.spad.
 \subsubsection{Completed spad files}
 Note well that none of the algebra stanzas should include these
 files in the preconditions otherwise we have an infinite compile
@@ -344,7 +353,7 @@ LAYER7=\
 @
 \subsection{Layer8}
 Depends on: A1AGG A1AGG- ARR2CAT FAMR FPC LIECAT LZSTAGG OREPCAT PSCAT 
-TRANFUN VSPACE XPOLYC
+TRANFUN VSPACE XPOLYC\\
 Used by next layer: BTAGG FLALG MATCAT SRAGG VECTCAT 
 <<layer8>>=
 
@@ -367,7 +376,7 @@ LAYER8=\
 
 @
 \subsection{Layer9}
-Depends on: BTAGG FLALG MATCAT SRAGG VECTCAT
+Depends on: BTAGG FLALG MATCAT SRAGG VECTCAT\\
 Used by next layer: IVECTOR PTCAT STRICAT 
 <<layer9>>=
 
@@ -379,7 +388,7 @@ LAYER9=\
 
 @
 \subsection{Layer10}
-Depends on: IVECTOR PTCAT STRICAT
+Depends on: IVECTOR PTCAT STRICAT\\
 Used by next layer: DIRPCAT FAXF PFECAT STRING
 <<layer10>>=
 
@@ -398,7 +407,7 @@ LAYER10=\
 
 @
 \subsection{Layer11}
-Depends on: DIRPCAT FAXF PFECAT STRING
+Depends on: DIRPCAT FAXF PFECAT STRING\\
 Used by next layer: DIOPS DPOLCAT FINRALG FRAC RMATCAT RRCC UPXSCAT
 <<layer11>>=
 
@@ -414,7 +423,8 @@ LAYER11=\
   ${OUT}/D01AJFA.o  ${OUT}/D01AKFA.o  ${OUT}/D01ALFA.o  ${OUT}/D01AMFA.o  \
   ${OUT}/D01APFA.o  ${OUT}/D01AQFA.o  ${OUT}/EMR.o      ${OUT}/EQ.o       \
   ${OUT}/ERROR.o    ${OUT}/EVALCYC.o  ${OUT}/E04DGFA.o  ${OUT}/E04FDFA.o  \
-  ${OUT}/E04GCFA.o  ${OUT}/E04JAFA.o  ${OUT}/FACUTIL.o  ${OUT}/FF.o       \
+  ${OUT}/E04GCFA.o  ${OUT}/E04JAFA.o  ${OUT}/E04UCFA.o  \
+  ${OUT}/FACUTIL.o  ${OUT}/FF.o       \
   ${OUT}/FFCG.o     ${OUT}/FFCGX.o    ${OUT}/FFFG.o     ${OUT}/FFFGF.o    \
   ${OUT}/FFHOM.o    ${OUT}/FFNB.o     ${OUT}/FFNBX.o    ${OUT}/FFPOLY.o   \
   ${OUT}/FFX.o      ${OUT}/FFSLPE.o   ${OUT}/FGLMICPK.o ${OUT}/FILE.o     \
@@ -463,7 +473,7 @@ LAYER11=\
 
 @
 \subsection{Layer12}
-Depends on: DIOPS DPOLCAT FINRALG FRAC RMATCAT RRCC UPXSCAT
+Depends on: DIOPS DPOLCAT FINRALG FRAC RMATCAT RRCC UPXSCAT\\
 Used by next layer: DIAGG FRAMALG MDAGG SMATCAT UPXSCCA
 <<layer12>>=
 
@@ -477,7 +487,7 @@ LAYER12=\
 
 @
 \subsection{Layer13}
-Depends on: DIAGG FRAMALG MDAGG SMATCAT UPXSCCA
+Depends on: DIAGG FRAMALG MDAGG SMATCAT UPXSCCA\\
 Used by next layer: FSAGG KDAGG MSETAGG MONOGEN
 <<layer13>>=
 
@@ -491,7 +501,7 @@ LAYER13=\
 
 @
 \subsection{Layer14}
-Depends on: FSAGG KDAGG MSETAGG MONOGEN
+Depends on: FSAGG KDAGG MSETAGG MONOGEN\\
 Used by next layer: TBAGG
 <<layer14>>=
 
@@ -506,25 +516,27 @@ LAYER14=\
 
 @
 \subsection{Layer15}
-Depends on: TBAGG
+Depends on: TBAGG\\
 Used by next layer: ALIST
 <<layer15>>=
 
 LAYER15=\
   ${OUT}/ALIST.o   ${OUT}/EQTBL.o   ${OUT}/GSTBL.o   ${OUT}/HASHTBL.o \
   ${OUT}/INTABL.o  ${OUT}/INTFTBL.o ${OUT}/INTPACK.o ${OUT}/IPF.o     \
-  ${OUT}/KAFILE.o  ${OUT}/PATRES.o  ${OUT}/STBL.o    ${OUT}/STRTBL.o  \
-  ${OUT}/TABLE.o   ${OUT}/TBCMPPK.o  \
+  ${OUT}/KAFILE.o  ${OUT}/PATRES.o  ${OUT}/PDEPACK.o ${OUT}/STBL.o    \
+  ${OUT}/STRTBL.o  ${OUT}/TABLE.o   ${OUT}/TBCMPPK.o  \
   layer15done
 
 @
 \subsection{Layer16}
-Depends on: ALIST
+Depends on: ALIST\\
+Used by next layer: ACF COMPCAT FFCAT FRNAALG FS OC QUATCAT RPOLCAT UTSCAT 
 <<layer16>>=
 
 LAYER16=\
   ${OUT}/ACF.o      ${OUT}/ACF-.o     ${OUT}/ACPLOT.o   ${OUT}/ANTISYM.o  \
   ${OUT}/ANY.o      ${OUT}/ASP12.o    ${OUT}/ASP27.o    ${OUT}/ASP28.o    \
+  ${OUT}/ASP30.o    \
   ${OUT}/ASP33.o    ${OUT}/ASP49.o    ${OUT}/ASP55.o    ${OUT}/ASP7.o     \
   ${OUT}/ASP78.o    ${OUT}/ASP8.o     ${OUT}/ASP9.o     ${OUT}/ATTRBUT.o  \
   ${OUT}/BOP.o      ${OUT}/BOP1.o     ${OUT}/COMMONOP.o ${OUT}/COMPCAT.o  \
@@ -535,11 +547,13 @@ LAYER16=\
   ${OUT}/FFP.o      ${OUT}/FLOAT.o    ${OUT}/FPARFRAC.o ${OUT}/FR.o       \
   ${OUT}/FRNAALG.o  ${OUT}/FRNAALG-.o ${OUT}/FS.o       ${OUT}/FS-.o      \
   ${OUT}/FST.o      ${OUT}/FUNCTION.o ${OUT}/GDMP.o     ${OUT}/GOPT.o     \
+  ${OUT}/GOPT0.o \
   ${OUT}/HACKPI.o   ${OUT}/IDEAL.o    ${OUT}/INFORM.o   ${OUT}/INFORM1.o  \
   ${OUT}/IPRNTPK.o  ${OUT}/IR.o       ${OUT}/ISUPS.o    ${OUT}/KERNEL.o   \
   ${OUT}/LIB.o      ${OUT}/LMDICT.o   ${OUT}/LODOOPS.o  ${OUT}/MATRIX.o   \
   ${OUT}/MKFLCFN.o  ${OUT}/MSET.o     ${OUT}/M3D.o      ${OUT}/NAGC02.o   \
-  ${OUT}/NAGC05.o   ${OUT}/NAGC06.o   ${OUT}/NAGD03.o   ${OUT}/NAGE01.o   \
+  ${OUT}/NAGC05.o   ${OUT}/NAGC06.o   ${OUT}/NAGD01.o   ${OUT}/NAGD02.o   \
+  ${OUT}/NAGD03.o   ${OUT}/NAGE01.o   \
   ${OUT}/NAGE02.o   ${OUT}/NAGE04.o   ${OUT}/NAGF07.o   ${OUT}/NAGS.o     \
   ${OUT}/NAGSP.o    ${OUT}/NREP.o     ${OUT}/NUMFMT.o   ${OUT}/OC.o       \
   ${OUT}/OC-.o      ${OUT}/ODEPACK.o  ${OUT}/ODERAT.o   ${OUT}/OMERR.o    \
@@ -556,112 +570,26 @@ LAYER16=\
 
 @
 \subsection{Layer17}
-
+Depends on: ACF COMPCAT FFCAT FRNAALG FS OC QUATCAT RPOLCAT UTSCAT
 <<layer17>>=
 
 LAYER17=\
-  layer17done
-
-@
-\subsection{Layer18}
-
-<<layer18>>=
-
-LAYER18=\
-  layer18done
-
-@
-\subsection{Layer19}
-
-<<layer19>>=
-
-LAYER19=\
-  layer19done
-
-
-@
-\subsection{Layer20}
-\subsubsection{Completed spad files}
-\begin{verbatim}
-algfact.spad.pamphlet (IALGFACT SAEFACT RFFACT SAERFFC ALGFACT)
-algfunc.spad.pamphlet (ACF ACFS AF)
-cmplxrt.spad.pamphlet (CMPLXRT)
-crfp.spad.pamphlet (CRFP)
-curve.spad.pamphlet (FFCAT MMAP FFCAT2 CHAVAR RDFF ALGFF)
-draw.spad.pamphlet (DRAWCFUN DRAW DRAWCURV DRAWPT)
-d01.spad.pamphlet (NAGD01)
-efstruc.spad.pamphlet (SYMFUNC TANEXP EFSTRUC ITRIGMNP TRIGMNIP CTRIGMNP)
-elemntry.spad.pamphlet (EF)
-elfuts.spad.pamphlet (ELFUTS)
-exprode.spad.pamphlet (EXPRODE)
-f01.spad.pamphlet (NAGF01)
-f02.spad.pamphlet (NAGF02)
-f04.spad.pamphlet (NAGF04)
-fspace.spad.pamphlet (ES ES1 ES2 FS FS2)
-fs2ups.spad.pamphlet (FS2UPS)
-funcpkgs.spad.pamphlet (FSUPFACT)
-gaussfac.spad.pamphlet (GAUSSFAC)
-gaussian.spad.pamphlet (COMPCAT COMPLPAT CPMATCH COMPLEX COMPLEX2 COMPFACT
-                        CINTSLPE)
-generic.spad.pamphlet (GCNAALG CVMP)
-genufact.spad.pamphlet (GENUFACT)
-genups.spad.pamphlet (GENUPS)
-infprod.spad.pamphlet (STINPROD INFPROD0 INPRODPF INPRODFF)
-intaf.spad.pamphlet (INTG0 INTPAF INTAF)
-intalg.spad.pamphlet (DBLRESP INTHERAL INTALG)
-intef.spad.pamphlet (INTEF)
-intpm.spad.pamphlet (INTPM)
-kovacic.spad.pamphlet (KOVACIC)
-liouv.spad.pamphlet (LF)
-lodof.spad.pamphlet (SETMN PREASSOC ASSOCEQ LODOF)
-manip.spad.pamphlet (FACTFUNC POLYROOT ALGMANIP SIMPAN TRMANIP)
-multfact.spad.pamphlet (INNMFACT MULTFACT ALGMFACT)
-naalg.spad.pamphlet (ALGSC SCPKG ALGPKG FRNAAF2)
-newpoly.spad.pamphlet (NSUP NSUP2 RPOLCAT NSMP)
-nlinsol.spad.pamphlet (RETSOL NLINSOL)
-numeigen.spad.pamphlet (IFSPRMELT.oNEP NREP NCEP)
-numeric.spad.pamphlet (NUMERIC DRAWHACK)
-numsolve.spad.pamphlet (INFSP FLOATRP FLOATCP)
-oct.spad.pamphlet (OC OCT OCTCT2)
-odealg.spad.pamphlet (ODESYS ODERED ODEPAL)
-openmath.spad.pamphlet (OMEXPR)
-pade.spad.pamphlet (PADEPAC PADE)
-patmatch2.spad.pamphlet (PMINS PMQFCAT PMPLCT PMFS PATMATCH)
-pfo.spad.pamphlet (FORDER RDIV PFOTOOLS PFOQ FSRED PFO)
-primelt.spad.pamphlet (PRIMELT FSPRMELT)
-quat.spad.pamphlet (QUATCAT QUAT QUATCT2)
-rdeef.spad.pamphlet (INTTOOLS RDEEF)
-rdesys.spad.pamphlet (RDETRS RDEEFS)
-riccati.spad.pamphlet (ODEPRRIC ODERTRIC)
-rule.spad.pamphlet (RULE APPRULE RULESET)
-sign.spad.pamphlet (TOOLSIGN INPSIGN SIGNRF LIMITRF)
-special.spad.pamphlet (DFSFUN ORTHPOL NTPOLFN)
-tools.spad.pamphlet (ESTOOLS ESTOOLS1 ESTOOLS2)
-triset.spad.pamphlet (TSETCAT GTSET PSETPK)
-tube.spad.pamphlet (TUBE TUBETOOL EXPRTUBE NUMTUBE)
-utsode.spad.pamphlet (UTSODE)
-\end{verbatim}
-
-<<layer20>>=
-
-LAYER20=\
   ${OUT}/ACFS.o     ${OUT}/ACFS-.o    ${OUT}/AF.o       ${OUT}/ALGFACT.o  \
   ${OUT}/ALGFF.o    ${OUT}/ALGMANIP.o ${OUT}/ALGMFACT.o ${OUT}/ALGPKG.o   \
   ${OUT}/ALGSC.o    ${OUT}/AN.o       ${OUT}/APPRULE.o  ${OUT}/ASP19.o    \
-  ${OUT}/ASP20.o    ${OUT}/ASP30.o    ${OUT}/ASP31.o    ${OUT}/ASP35.o    \
+  ${OUT}/ASP20.o    ${OUT}/ASP31.o    ${OUT}/ASP35.o    \
   ${OUT}/ASP41.o    ${OUT}/ASP42.o    ${OUT}/ASP74.o    ${OUT}/ASP77.o    \
   ${OUT}/ASP80.o    ${OUT}/CINTSLPE.o ${OUT}/COMPFACT.o ${OUT}/COMPLEX.o  \
   ${OUT}/COMPLPAT.o ${OUT}/CMPLXRT.o  ${OUT}/CPMATCH.o  ${OUT}/CRFP.o     \
   ${OUT}/CTRIGMNP.o ${OUT}/D01WGTS.o  ${OUT}/D02AGNT.o  ${OUT}/D03EEFA.o  \
   ${OUT}/DBLRESP.o  ${OUT}/DERHAM.o   ${OUT}/DFSFUN.o   ${OUT}/DRAWCURV.o \
-  ${OUT}/E04NAFA.o  ${OUT}/E04UCFA.o  ${OUT}/EF.o       ${OUT}/EFSTRUC.o  \
+  ${OUT}/E04NAFA.o  ${OUT}/EF.o       ${OUT}/EFSTRUC.o  \
   ${OUT}/ELFUTS.o   ${OUT}/ESTOOLS.o  ${OUT}/EXPEXPAN.o ${OUT}/EXPRODE.o  \
   ${OUT}/EXPRTUBE.o ${OUT}/EXPR2.o    ${OUT}/FC.o       ${OUT}/FDIVCAT.o  \
   ${OUT}/FDIVCAT-.o ${OUT}/FDIV2.o    ${OUT}/FFCAT2.o   ${OUT}/FLOATCP.o  \
-  ${OUT}/FORDER.o   ${OUT}/FORTRAN.o  ${OUT}/FSRED.o    ${OUT}/FSUPFACT.o \
-  ${OUT}/FRNAAF2.o  ${OUT}/FSPECF.o   ${OUT}/FS2.o      ${OUT}/FS2UPS.o   \
+  ${OUT}/FORDER.o   ${OUT}/FORTRAN.o  ${OUT}/FRNAAF2.o  ${OUT}/FSRED.o    \
+  ${OUT}/FSUPFACT.o ${OUT}/FSPECF.o   ${OUT}/FS2.o      ${OUT}/FS2UPS.o   \
   ${OUT}/GAUSSFAC.o ${OUT}/GCNAALG.o  ${OUT}/GENUFACT.o ${OUT}/GENUPS.o   \
-  ${OUT}/GOPT0.o \
   ${OUT}/GTSET.o    ${OUT}/GPOLSET.o  ${OUT}/IAN.o      ${OUT}/INEP.o     \
   ${OUT}/INFPROD0.o ${OUT}/INFSP.o    ${OUT}/INPRODFF.o ${OUT}/INPRODPF.o \
   ${OUT}/INTAF.o    ${OUT}/INTALG.o   ${OUT}/INTEF.o    ${OUT}/INTG0.o    \
@@ -669,11 +597,10 @@ LAYER20=\
   ${OUT}/ITRIGMNP.o ${OUT}/JORDAN.o   ${OUT}/KOVACIC.o  ${OUT}/LF.o       \
   ${OUT}/LIE.o      ${OUT}/LODOF.o    ${OUT}/LSQM.o     ${OUT}/OMEXPR.o   \
   ${OUT}/MCMPLX.o   ${OUT}/MULTFACT.o ${MID}/clique1.spad \
-  ${OUT}/NAGD01.o   ${OUT}/NAGD02.o   \
   ${OUT}/NAGF01.o   ${OUT}/NAGF02.o   ${OUT}/NAGF04.o   ${OUT}/NCEP.o     \
   ${OUT}/NLINSOL.o  ${OUT}/NSMP.o     ${OUT}/NUMERIC.o  ${OUT}/OCT.o      \
   ${OUT}/OCTCT2.o   ${OUT}/ODEPAL.o   ${OUT}/ODERTRIC.o ${OUT}/PADE.o     \
-  ${OUT}/PAN2EXPR.o ${OUT}/PDEPACK.o  ${OUT}/PFO.o      ${OUT}/PFOQ.o     \
+  ${OUT}/PAN2EXPR.o ${OUT}/PFO.o      ${OUT}/PFOQ.o     \
   ${OUT}/PICOERCE.o ${OUT}/PMASSFS.o  ${OUT}/PMFS.o     ${OUT}/PMPREDFS.o \
   ${OUT}/PSETPK.o   ${OUT}/QUAT.o     ${OUT}/QUATCT2.o  ${OUT}/RADFF.o    \
   ${OUT}/RDEEF.o    ${OUT}/RDEEFS.o   ${OUT}/RDIV.o     ${OUT}/RSETCAT.o  \
@@ -683,6 +610,31 @@ LAYER20=\
   ${OUT}/ULSCCAT.o  \
   ${OUT}/ULSCCAT-.o ${OUT}/UPXSSING.o ${OUT}/UTSODE.o   ${OUT}/UTSODETL.o \
   ${OUT}/UTSSOL.o   ${OUT}/UTS2.o     ${OUT}/WUTSET.o  \
+  layer17done
+
+@
+\subsection{Layer18}
+
+<<layer18>>=
+
+LAYER18=\
+  layer18done
+
+@
+\subsection{Layer19}
+
+<<layer19>>=
+
+LAYER19=\
+  layer19done
+
+
+@
+\subsection{Layer20}
+
+<<layer20>>=
+
+LAYER20=\
   layer20done
     
 @
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 1a34cd9..e0cedab 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -857,6 +857,8 @@ algebra/Makefile move layer 10, MAPPKG4 <br/>
 algebra/Makefile move layers 11, 12, 13 <br/>
 <a href="patches/20081225.04.tpd.patch">20081225.04.tpd.patch</a>
 algebra/Makefile move layers 15, 16, 17, 18, 19 <br/>
+<a href="patches/20081226.01.tpd.patch">20081226.01.tpd.patch</a>
+algebra/Makefile rearrange build order <br/>
 
  </body>
 </html>
